/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.amap.lidar.amapvox.gui;

import fr.amap.lidar.amapvox.commons.LidarScan;
import fr.amap.amapvox.io.tls.rsp.Rsp;
import fr.amap.amapvox.io.tls.rsp.RxpScan;
import fr.amap.amapvox.io.tls.rsp.Scans;
import java.io.IOException;
import java.util.ArrayList;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBoxTreeItem;
import javafx.scene.control.cell.CheckBoxTreeCell;
import javax.vecmath.Matrix4d;

/**
 *
 * @author calcul
 */
public class RiscanProjectExtractor extends LidarProjectExtractor {

    private final Button buttonSwapFullDecimated;
    private boolean swap;

    public RiscanProjectExtractor() {

        super();

        buttonSwapFullDecimated = new Button("Swap full/decimated");
        swap = false;
        buttonSwapFullDecimated.setOnAction((ActionEvent event) -> {
            selectLeavesContainingString(extractorFrameController.getRoot(), "mon", swap);
            swap = !swap;
        });
        extractorFrameController.getHboxSelection().getChildren().add(buttonSwapFullDecimated);
    }

    private void selectLeavesContainingString(CheckBoxTreeItem node, String string, boolean contains) {

        ObservableList<CheckBoxTreeItem> childrens = node.getChildren();

        for (CheckBoxTreeItem children : childrens) {

            if (children.isLeaf()) {

                if (((LidarScan) children.getValue()).getName().contains(string)) {
                    children.setSelected(contains);
                } else {
                    children.setSelected(!contains);
                }
            } else {
                selectLeavesContainingString(children, string, contains);
            }
        }
    }

    public void init(Rsp rsp) throws IOException {

        extractorFrameController.getRoot().setExpanded(true);

        ArrayList<Scans> rxpList = rsp.getRxpList();

        if (rxpList.isEmpty()) {
            throw new IOException("Could not find any scan tagged as \"registered\" in RSP project " + rsp.getProjectName());
        }

        extractorFrameController.getRoot().getChildren().clear();

        boolean monDefined = false;
        for (Scans scans : rxpList) {

            CheckBoxTreeItem<LidarScan> item = new CheckBoxTreeItem(new LidarScan(null, null, scans.getName()));

            for (RxpScan scan : scans.getScans()) {
                CheckBoxTreeItem<LidarScan> checkBoxTreeItemFull = new CheckBoxTreeItem(
                        new LidarScan(scan.getFile(), new Matrix4d(scan.getSopMatrix()), scan.getName()));
                checkBoxTreeItemFull.setSelected(true);
                item.getChildren().add(checkBoxTreeItemFull);
                if (scan.getName().contains("mon")) {
                    monDefined = true;
                }
            }
            item.setExpanded(true);
            item.setSelected(true);
            extractorFrameController.getRoot().getChildren().add(item);
        }

        // select root tree checkbox
        extractorFrameController.getRoot().setSelected(!rxpList.isEmpty());

        if (monDefined) {
            buttonSwapFullDecimated.setDisable(false);
            // perform first click to disable MON file
            buttonSwapFullDecimated.fire();
        } else {
            buttonSwapFullDecimated.setDisable(true);
        }

        extractorFrameController.getTreeViewLidarProjectContent().setCellFactory(CheckBoxTreeCell.<LidarScan>forTreeView());
        extractorFrameController.getTreeViewLidarProjectContent().setRoot(extractorFrameController.getRoot());

    }
}
